/*****************************************************************************
* Copyright (c) 2005 Sena Technologies, Inc., All Rights Reserved
*
* This software contains proprietary and confidential information of Sena
* Technologies Inc.  By accepting transfer of this copy, Recipient agrees
* to retain this software in confidence, to prevent disclosure to others,
* and to make no use of this software other than that for which it was
* delivered.  This is an unpublished copyrighted work of Sena Technologies,
* Inc.  
*
* Sena Technologies, Inc. 210 Yangjae-dong Seocho-gu, Seoul, Korea
*
*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winsock2.h>
#include <windowsx.h>
#include <process.h>
#include <conio.h>
#include <time.h>
#include "rc4.h"

#define BUF_SIZE 1024

char host[64] = "192.168.11.161";
int port = 7002;
char key[64] = "1111";
SOCKET s = INVALID_SOCKET;
BOOL bexit = FALSE;

void usage()
{
	printf("\nusage: rc4_client args\n\n");
	printf(" -host host              - use -connect instead\n");
	printf(" -port port              - use -connect instead\n");
	printf(" -connect host:port      - who to connect to\n");
	printf(" -key arg                - key string to use in rc4 encrytion/decryption\n");

	exit(-1);
}


int extract_host(char *host, int *port, char *str)
{
	char *p;
	
	p = strchr(str, ':');
	if (p == NULL) return -1;
	*p++ = '\0';
	sprintf(host, "%s", str);
	*port = atoi(p);
	return 0;
}	

void recv_thread(void *arg);

int main(int argc, char **argv)
{
	int i, ret;
	WSADATA wsadata;
	struct hostent *hostinfo;
	struct sockaddr_in addr;
	int addr_len;
	char buf[BUF_SIZE];
	int buf_len;
	rc4_key ctx;
	DWORD hthread;
	
	for (i=1; i<argc; i++) {
		if (!strcmp(argv[i], "-key")) {
			sprintf(key, "%s", argv[++i]);
		}
		else if (!strcmp(argv[i], "-host")) {
			sprintf(host, "%s", argv[++i]);
		}		
		else if (!strcmp(argv[i], "-port")) {
			port = atoi(argv[++i]);
		}		
		else if (!strcmp(argv[i], "-connect")) {
			if (extract_host(host, &port, argv[++i])) usage();
		}		
		else usage();
	}
	
	if (strlen(key) == 0 || strlen(host) == 0 || port <= 0) usage();

/*
	initialize Windows sockets
*/
	WSAStartup(MAKEWORD(1,1), &wsadata);
/*	
	connect to the host 
*/

	hostinfo = gethostbyname(host);
	if (hostinfo == NULL) {
		printf("cannot resolve %s\n", host);
		exit(-1);
	}
	
	s = socket(AF_INET, SOCK_STREAM, 0);
	addr.sin_family = AF_INET;
	addr.sin_port = htons((unsigned short) port);
	addr.sin_addr = *(struct in_addr *) *hostinfo->h_addr_list;
	addr_len = sizeof(addr);
	
	ret = connect(s, (struct sockaddr *) &addr, addr_len);
	if (ret < 0) {
		printf("cannot connect to %s:%d\n", host, port);
		closesocket(s);
		exit(-1);
	}
	
	printf("CONNECTED\n");
	
	hthread = _beginthread(recv_thread, 0, NULL);
	
	prepare_key(key, strlen(key), &ctx);

	while(!bexit) {
		if (WAIT_OBJECT_0 == WaitForSingleObject(GetStdHandle(STD_INPUT_HANDLE), 1000)) {			
			gets(buf);
			buf_len = strlen(buf);
			buf[buf_len++] = '\r';
			if (buf[0] == 'Q') {
				printf("DONE\n");
				bexit = TRUE;
				break;
			}
			
			rc4(buf, buf_len, &ctx);
			send(s, buf, buf_len, 0);
		}
	}

	WaitForSingleObject((HANDLE) hthread, 1000);

	closesocket(s);
	exit(0);
}


		
void recv_thread(void *arg)
{
	char buf[BUF_SIZE];
	int ret;
	rc4_key ctx;
	struct timeval tv;
	fd_set fds;

	prepare_key(key, strlen(key), &ctx);

	while(!bexit) {
		tv.tv_sec = 1;
		tv.tv_usec = 0;
		
		FD_ZERO(&fds);
		FD_SET(s, &fds);

		ret = select (0, &fds, NULL, NULL, &tv);
		if (ret == 0 ) continue;
		else if (ret <0) break;
		else {
			ret = recv(s, buf, 	sizeof(buf)-1, 0);
			if (ret>0) {
				rc4(buf, ret, &ctx);
				buf[ret] = '\0';
				printf("%s", buf);
			}
			else {
				printf("DONE\n");
				bexit = TRUE;
				break;
			}
		}
	}
	_endthread();

}

